// CSVFiles.h : Declaration of the CCSVFiles

#pragma once
#include "resource.h"       // main symbols

#include "SampleExportPluginVS2005.h"


#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif


// CCSVFiles

class ATL_NO_VTABLE CCSVFiles :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CCSVFiles, &CLSID_CSVFiles>,
	public IDispatchImpl<ICSVFiles, &IID_ICSVFiles, &LIBID_SampleExportPluginVS2005Lib, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CCSVFiles()
  {
	}

DECLARE_REGISTRY_RESOURCEID(IDR_CSVFILES)

BEGIN_COM_MAP(CCSVFiles)
	COM_INTERFACE_ENTRY(ICSVFiles)
	COM_INTERFACE_ENTRY(IDispatch)
  COM_INTERFACE_ENTRY(IDataExportPlugin)  // !!!*** Don't forget to add this interface to the COM MAP***!!!
	COM_INTERFACE_ENTRY(IExternalPlugin)    // !!!*** Don't forget to add this interface to the COM MAP***!!!
END_COM_MAP()



	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}

  // Step 1) Please see the extra registry script in the CSVFiles.rgs file. You must 
  // add these extra registry instructions into your rgs file for Iads to consider your custom dll as
  // a potential plugin. See bottom of the CSVFiles.rgs file for specifics 
  // HKEY_LOCAL_MACHINE
  // {
	//   NoRemove SOFTWARE
	//   {
	// 	  NoRemove 'Symvionics, Inc.'
	// 	  {
	// 		  NoRemove IADS
	// 		  {
	// 			  NoRemove ClientWorkstation
	// 			  {
	// 				  NoRemove Addins
	// 				  {
	// 					  ForceRemove YourPluginProgId
	// 					  {
	// 						  val FriendlyName = s 'You Plugin Name That Will Appear on the DataExport menu'
	// 						  val LoadBehavior = d 3
	// 					  }
	// 				  }					
	// 			  }
	// 		  }
	// 	  }
	//   }
  // }


  // Step 2) IExternalPlugin interface. You *must* define these functions or you will get a compile/link error.
  // This interface is the mechanism Iads uses to hook the plugin into the menu system. 
  STDMETHOD(OnConnection)( IApplication* Application )
  {
    if ( !Application ) return E_POINTER;

    mIads = Application; // CComPtr class performs AddRef automatically

    // Plug ourself into the Iads Export Plugin branch
    CComPtr<IPlugins> plugins;
    mIads->get_Plugins( &plugins );
    if ( !plugins.p ) return E_FAIL;

    CComPtr<IExternalPlugin> pP;
    this->QueryInterface( IID_IExternalPlugin, (void**)&pP ); _ASSERT( pP.p );

    plugins->Add( L"Example Export Plugin", iadsDataExportPlugin, pP, NULL/*CatagoryNotUsedAtThisPoint*/ );

    return S_OK;
  }
  STDMETHOD(OnDisconnection)( void )
  {
    // Do any immediate cleanup here, but mainly in the FinalDestruct function
    return S_OK;
  }

  // PerformDataExport - This is where all your export code needs to go. You *must* define and use this function
  // name to perform your export, or you will get compile errors. This function implements the IDataExport interface
  // in which the Iads client calls to trigger the export action.
  STDMETHOD(PerformDataExport)( IDataDisplay* SelectedDisplay, BSTR DataGroupName )
  {
    if( !SelectedDisplay && !DataGroupName ) return E_POINTER;
    
    // CComPtr will Release the objects once this function looses scope so no need to do that yourself
    CComPtr<IIadsTime> startTime, endTime;

    // Get the selected time range from the display
    SelectedDisplay->GetSelectedTimeRange( &startTime, &endTime );
    if( !startTime.p || !endTime.p ) return E_POINTER;

    // If the Data GroupName is NULL, then the user selected "Data Export->Your Plugin->Selected Displays".
    // In this case, we need to use the IDataDisplay pointer to get all the 
    // parameters for which to export data over the time range
    if( DataGroupName == NULL )
    {
      ExportSelectedDisplay( SelectedDisplay, startTime, endTime );
    }
    // Otherwise, Data Group Export
    else
    {
      ExportDataGroup( DataGroupName, startTime, endTime );
    }

    return S_OK ;
  }

  HRESULT ExportSelectedDisplay( IDataDisplay* SelectedDisplay, IIadsTime* startTime, IIadsTime* endTime )
  {
    // Get the "active parameter" from the display (the one with focus). 
    CComPtr<IParameter> activeParameter;
    HRESULT hr = SelectedDisplay->get_ActiveParameterPtr( &activeParameter );
    if( hr != S_OK || !activeParameter.p ) return E_POINTER;

    // Create the destination CSV file name. You could query the user with a FileOpen box at this point
    char fileName[MAX_PATH*10] ;
    sprintf( fileName, "c:\\SampleExportPluginOutput.csv" );

    // Export the data for a single parameter
    return ExportDataForSingleParameter( activeParameter, startTime, endTime, fileName );
  }


  // ExportDataForSingleParameter
  //  this is a helper function to get the data for the Parameter and export to the output file type
  //  this is where your code will go.  This is the only location you need to modify for your particular output type
  HRESULT ExportDataForSingleParameter( IParameter* Param, IIadsTime* StartTime, IIadsTime* EndTime, char* FileName )
  {
    if( !Param || !StartTime || !EndTime ) return E_POINTER ;

    CComVariant vData ;
    CComPtr<IIadsTime> CurrentTime; 
    HRESULT hr = ::CoCreateInstance( CLSID_IadsTime, NULL, CLSCTX_ALL, IID_IIadsTime, (void**)&CurrentTime ) ;
    if ( hr != S_OK || CurrentTime.p == NULL ) return hr;

    FILE* fp = fopen( FileName, "w") ;
    if( !fp ) return E_FAIL ;

    CComBSTR bName; Param->get_Name(&bName) ; 
    char cName[1000] ; ::wcstombs( cName, bName, 1000 ) ;
    //double sr; Param->get_SampleRate(&sr) ;
    fprintf( fp, "%s,%s\n", "Time", cName ) ;

    // Now that we have a valid parameter - let's go get the data at the time requested from the
    // selection on the strip chart
    Param->put_CurrentTime( StartTime ) ;

    // Need to check if this an aperodic parameter becasue the data fetch techniuqe is
    // different of it is.
    VARIANT_BOOL isAperiodic, isLess ;
    Param->get_IsAperiodic( &isAperiodic ) ;

    // Aperiodic
    if( isAperiodic == VARIANT_TRUE )
    {
      // This is mandatory in order to eliminate LGV fill.
      Param->put_InterpolatedSampleRate(0.0) ;

      // Continue to loop while the time returned isn't greater the our End Time
      do
      {
        Param->Value2( iadsTimeAdvanceFoward, &vData, &CurrentTime ) ;
        CComBSTR bTime ; CurrentTime->get_TimeString( &bTime ) ;
        char cTime[1000] ; ::wcstombs( cTime, bTime, 1000 ) ;

        // Now check the data type returned and do the export

        // *** This is where your code will go ***
        if( vData.vt == VT_R8 )
        {
          double dval = vData.dblVal ;
          fprintf(fp, "%s,%f\n", cTime, dval ) ;
        }
        CurrentTime->IsLess(EndTime, &isLess) ;

      } while( isLess == VARIANT_TRUE ) ;
    }
    else // Periodic
    {
      double sr ;
      long totalPoints ;
      Param->get_SampleRate( &sr ) ;
      Param->GetNumDataPoints( StartTime, EndTime, &totalPoints ) ;
      register IIadsTime* ct = CurrentTime.p;
      for( register int n=0; n < totalPoints; n++ )
      {
        Param->Value2( iadsTimeAdvanceFoward, &vData, &ct ) ;
        CComBSTR bTime ; CurrentTime->get_TimeString( &bTime ) ;
        char cTime[1000] ; ::wcstombs( cTime, bTime, 1000 ) ;

        // *** This is where your code will go ***
        if ( vData.vt == VT_R4 ) 
          fprintf(fp, "%s,%f\n", cTime, vData.fltVal );
        else if( vData.vt == VT_R8 )
          fprintf(fp, "%s,%lf\n", cTime, vData.dblVal );
        else if ( vData.vt == VT_I4 ) 
          fprintf(fp, "%s,%d\n", cTime, vData.lVal );
        else if ( vData.vt == VT_UI4 ) 
          fprintf(fp, "%s,0x%X\n", cTime, vData.ulVal );
        else if ( vData.vt == VT_BSTR )
        {
          char v[1000]; ::wcstombs( v, vData.bstrVal, 1000 );
          fprintf(fp, "%s,%s\n", cTime, v );
        }
        else 
          fprintf(fp, "%s,????\n", cTime );

        // *** End User code ***
      }
    }
    
    fflush( fp );
    fclose( fp );

    return S_OK ;
  }

  HRESULT ExportDataGroup( BSTR DataGroupName, IIadsTime* StartTime, IIadsTime* EndTime )
  {
    // Get the Configuration object from the Iads object
    CComPtr<IConfiguration> cf ;
    HRESULT hr = mIads->get_Configuration( &cf );
    if( hr != S_OK || !cf.p ) return hr;

    // Get the DataGroups object from the Configuration 
    CComPtr<IDataGroups> dataGroups;
    hr = cf->get_DataGroups( &dataGroups );
    if( hr != S_OK || !dataGroups.p ) return hr;

    // Get the DataGroup by name
    CComPtr<IDataGroup> dataGroup;
    CComVariant dgName = DataGroupName;
    hr = dataGroups->Item( dgName, &dataGroup );
    if( hr != S_OK || !dataGroup.p ) return hr;

    long numParams;
    dataGroup->get_Count( &numParams );

    CComPtr<IParameter>* params = new CComPtr<IParameter>[numParams];
    long numParamsCreated = 0;

    for ( register int i=0; i<numParams; i++ )
    {
      CComVariant index = i;
      CComBSTR pName;
      dataGroup->Item( index, &pName );

      hr = cf->CreateParameter( pName, &params[numParamsCreated] );
      if ( hr != S_OK )
        ::OutputDebugString( "Failed to create parameter" );
      else
        numParamsCreated++; 
    }

    // Since the CSV file is squared off, we will need to interpolate each parameter at the same identical 
    // sample rate. In this step, we will find the largest sample rate of the group. This will be our default rate
    double outputSR = 0.0;
    for ( register int j=0; j<numParamsCreated; j++ )
    {
      double sr;
      params[j]->get_SampleRate( &sr );
      if ( sr > outputSR )
        outputSR = sr;
    }

    // In this section, we will access some of the DataGroup "options" that reside in the PropertyBag column
    // of the DataGroup table for this specific DataGroup.
    // There are many more DataGroup options. You can check if any are set by calling dataGroup->get_HasActiveProperties();
    // In this example, we are going to focus in on two in particular

    // See if the user requested an output sample rate. If so, we will use it. If not, we will continue on using the highest rate of the group
    double requestedSr;
    hr = dataGroup->get_SampleRate( &requestedSr );
    if ( hr == S_OK )
    {
      // If the return value is S_OK (vs S_FALSE), the user did define a requested output sample rate
      outputSR = requestedSr; 
    }
    else
    {
      // One more step. If the SampleRate wasn't requested, now we check to see if the "DecimationFactor" 
      // DataGroup option is requested by the user. If so, we will apply it to the max rate of the group 
      long decimationFactor;
      hr = dataGroup->get_DecimationFactor( &decimationFactor );
      if ( hr == S_OK )
        outputSR = outputSR / (double)decimationFactor; // User requested decimation factor
    }

    // Now, we have finally obtained the target sample rate. Set all the DataGroup parameters so they run
    // at this "interpolated" rate
    for ( register int k=0; k<numParamsCreated; k++ )
    {
      params[k]->put_InterpolatedSampleRate( outputSR );
    }

    // In preparation for export, we'll create an IadsTime object. We can use this to extract time
    // and create a string for the the CSV file
    CComVariant vData;
    CComPtr<IIadsTime> CurrentTime; 
    hr = ::CoCreateInstance( CLSID_IadsTime, NULL, CLSCTX_ALL, IID_IIadsTime, (void**)&CurrentTime ) ;
    if ( hr != S_OK || CurrentTime.p == NULL ) return hr;

    // Create the CSV file
    char FileName[MAX_PATH*10] ;
    sprintf( FileName, "c:\\SampleExportPluginOutput.csv" );
    FILE* fp = fopen( FileName, "w") ;
    if( !fp ) return E_FAIL ;

    // Create the CSV file header row (Time,ParameterNames...)
    fprintf( fp, "Time" );
    CComBSTR pName;
    for ( register int i=0; i<numParamsCreated; i++ )
    {
      params[i]->get_Name( &pName );
      char cName[1000]; 
      ::wcstombs( cName, pName, 1000 );
      fprintf( fp, ",%s", cName );
    }
    fprintf( fp, "\n" );

    // Start the process by directing all the Parameters in the group to the StartTime of the data export
    for ( register int l=0; l<numParamsCreated; l++ )
    {
      params[l]->put_CurrentTime( StartTime );
    }

    // Determine how many points to export. Since all the parameters are running the same sample rate, we'll just query the first in the group
    long totalPoints;
    params[0]->GetNumDataPoints( StartTime, EndTime, &totalPoints );

    IIadsTime* ct = CurrentTime.p;
    for( register int m=0; m < totalPoints; m++ )
    {
      for ( register int n=0; n<numParamsCreated; n++ )
      {
        // If this is the first parameter in the group, grab the time value and output to the file
        if ( n == 0 )
        {
          // Get the current value and advance to the next point
          params[n]->Value2( iadsTimeAdvanceFoward, &vData, &ct );
          CComBSTR bTime; CurrentTime->get_TimeString( &bTime );
          char cTime[1000]; ::wcstombs( cTime, bTime, 1000 );
          fprintf( fp, "%s", cTime );
        }
        else
        {
          // Get the current value and advance to the next point
          params[n]->Value2( iadsTimeAdvanceFoward, &vData, NULL );
        }

        // Depending on the data type returned, output the appropriate format
        if ( vData.vt == VT_R4 ) 
          fprintf( fp, ",%f", vData.fltVal );
        else if ( vData.vt == VT_R8 )
          fprintf( fp, ",%lf", vData.dblVal );
        else if ( vData.vt == VT_I4 ) 
          fprintf( fp, ",%d", vData.lVal );
        else if ( vData.vt == VT_UI4 ) 
          fprintf( fp, ",0x%X", vData.ulVal );
        else if ( vData.vt == VT_BSTR ) 
        {
          char t[1000]; 
          ::wcstombs( t, vData.bstrVal, 1000 );
          fprintf( fp, ",%s", t );
        }
        else
        {
          fprintf( fp, ",????" );
        }
      }

      // Done with this row and on to the next
      fprintf( fp, "\n" );
    }

    for ( register int z=0; z<numParamsCreated; z++ )
    {
      params[z].Release();
    }
    delete [] params;

    fflush( fp );
    fclose( fp );

    return S_OK;
  }


public:

  CComPtr<IApplication> mIads ;
};

OBJECT_ENTRY_AUTO(__uuidof(CSVFiles), CCSVFiles)
